angular.module('mrt', ['ionic','ngRoute'])
// pending truncate table if records not match
.service('servicejs', function() {
	
	this.dataOutdated = function($scope){
	
		var request = new XMLHttpRequest();
			request.open("GET", "properties.txt", true);
			request.onreadystatechange = function(){
				if (request.readyState == 4) {
					if (request.status == 200 || request.status == 0) {
					
						var version = request.responseText.trim().split("=")[1];
						console.log("version:"+version);
						var currentVersion = window.localStorage['dataVersion'];
						
						if(version != currentVersion){
						console.log("version:empty");
							window.localStorage['dataVersion'] = version;
							window.localStorage['updated'] = false;
						}else{
							window.localStorage['updated'] = true;
						}
						
					}
				}
			}
			
			request.send();
	},
	this.init = function($scope){
	
		 window.localStorage.clear();
		 
		 var trainLineRequest = new XMLHttpRequest();
			trainLineRequest.open("GET", "data/lines.txt", true);
			trainLineRequest.onreadystatechange = function(){
				if (trainLineRequest.readyState == 4) {
					if (trainLineRequest.status == 200 || trainLineRequest.status == 0) {
						
						var trainLine = [];
						var resSplit = trainLineRequest.responseText.split( "\n" );
						
						
						
							for(var i = 0; i < resSplit.length; i++){
								
								var lineSplit = resSplit[i].split("|");
								
								trainLine.push({code: lineSplit[0], title:lineSplit[1],color:lineSplit[2]});
							}
						
						window.localStorage['trainLine'] = angular.toJson(trainLine);
						 $scope.$apply(function () {
						$scope.lines = trainLine;
						});
						
						var nRequest = new Array();
						for (var i=0; i<trainLine.length; i++){
					   (function(i) {
						  nRequest[i] = new XMLHttpRequest();
						  nRequest[i].open("GET", "data/"+trainLine[i].code+".txt", true);
						  nRequest[i].onreadystatechange = function (oEvent) {
							 if (nRequest[i].readyState === 4) {
								if (nRequest[i].status === 200) {
								  
									var train = [];
									var resSplit = nRequest[i].responseText.trim().split( "\n" );
								
										for(var x = 0; x < resSplit.length; x++){
											
											var lineSplit = resSplit[x].split("|");
											var inter = [];
											var interString = lineSplit[2];
											
											if(interString != ''){
											
												var interSplit = interString.split(";");
												
												if(interSplit.length > 0){
												
													for(var j = 0; j < interSplit.length; j++){
														var color = '#009530';
													
														if(interSplit[j].substring(0,2) == 'EW'){
															color = '#009530';
														}else if(interSplit[j].substring(0,2) == 'NS'){
															color = '#DC241F';
														}else if(interSplit[j].substring(0,2) == 'NE'){
															color = '#9016B2';
														}else if(interSplit[j].substring(0,2) == 'CC'){
															color = '#FF9A00';
														}else if(interSplit[j].substring(0,2) == 'DT'){
															color = '#0354A6';
														}
														inter.push({code: interSplit[j], color: color});
													}
													
												}else{
													
													var color = '#009530';
													
													if(interString.substring(0,2) == 'EW'){
														color = '#009530';
													}else if(interString.substring(0,2) == 'NS'){
														color = '#DC241F';
													}else if(interString.substring(0,2) == 'NE'){
														color = '#9016B2';
													}else if(interString.substring(0,2) == 'CC'){
														color = '#FF9A00';
													}else if(interString.substring(0,2) == 'DT'){
														color = '#0354A6';
													}
													inter.push({code: interString, color: color});
												}
												
											}
											console.log("lineSplit[3]:"+lineSplit[3]);
											train.push({code: lineSplit[0].trim(), title:lineSplit[1].trim(),interchange:inter,mall:lineSplit[3].trim(),library:lineSplit[4].trim()});
										}
										
										window.localStorage[trainLine[i].code] = angular.toJson(train);
										$scope.$apply(function () {
											
											if(trainLine[i].code == 'EW'){
												$scope.EW = train;
											}else if(trainLine[i].code == 'NS'){
												$scope.NS = train;
											}else if(trainLine[i].code == 'NE'){
												$scope.NE = train;
											}else if(trainLine[i].code == 'CC'){
												$scope.CC = train;
											}else if(trainLine[i].code == 'DT'){
												$scope.DT = train;
											}
										});
								} else {
								  console.log("Error", nRequest[i].statusText);
								}
							 }
						  };
						  nRequest[i].send(null);
					   })(i);
					}

					var nMallRequest = new Array();
						for (var k=0; k<trainLine.length; k++){
					   (function(k) {
						  nMallRequest[k] = new XMLHttpRequest();
						  nMallRequest[k].open("GET", "data/"+trainLine[k].code+"_mall.txt", true);
						  nMallRequest[k].onreadystatechange = function (oEvent) {
						   
							 if (nMallRequest[k].readyState === 4) {
							
								if (nMallRequest[k].status === 200 && nMallRequest[k].responseText.trim() != '') {
									
									var mallResSplit = nMallRequest[k].responseText.trim().split( "\n" );
								
										for(var l = 0; l < mallResSplit.length; l++){
											console.log("mallResSplit[l]:", mallResSplit[l]);
											var mallLineSplit = mallResSplit[l].split("|");
											var mall = [];
											mall.push({code: mallLineSplit[0].trim(), title:mallLineSplit[1].trim(),address:mallLineSplit[2].trim()});
											window.localStorage.setItem( mallLineSplit[0].trim()+"_mall",angular.toJson(mall));
											console.log("title:mallLineSplit[1].trim()", mallLineSplit[1].trim());
										}
								} else {
								  console.log("Error", nMallRequest[k].statusText);
								}
							 }
						  };
						  nMallRequest[k].send(null);
					   })(k);
					}
			
						
					}
				}
			}
			trainLineRequest.send();
			

					
		
	  var line = {code:'NS',title:'North South Line',header:'bar-assertive',color:'#DC241F'};
	  $scope.type = 'Shopping Mall';
	  $scope.activeLine = line;
	  
	  
	  $scope.hide();
	
		
	},
	this.selectAllTrainLine = function($scope){
	  
	  var line = {code:'NS',title:'North South Line',header:'bar-assertive',color:'#DC241F'};
	  $scope.type = 'Shopping Mall';
	  $scope.activeLine = line;
	  
	  var trainLineString = window.localStorage['trainLine'];
      if(trainLineString) {
        $scope.lines = angular.fromJson(trainLineString);
      }
	  
	  var ewString = window.localStorage['EW'];
      if(ewString) {
        $scope.EW = angular.fromJson(ewString);
      }
	  
	  var nsString = window.localStorage['NS'];
      if(nsString) {
        $scope.NS = angular.fromJson(nsString);
      }
	
	   var ccString = window.localStorage['CC'];
      if(ccString) {
        $scope.CC = angular.fromJson(ccString);
      }
	  
	  var dtString = window.localStorage['DT'];
      if(dtString) {
        $scope.DT = angular.fromJson(dtString);
      }
	  
	  var neString = window.localStorage['NE'];
      if(neString) {
        $scope.NE = angular.fromJson(neString);
      }
	  $scope.hide();
		
	};
	//singleton containing all methods to be called
	
})

.config(['$routeProvider',  function($routeProvider) {
    $routeProvider.
      when('/EW', {
        templateUrl: 'view/EW.html',
        controller: 'EWController'
    }).when('/NS', {
        templateUrl: 'view/NS.html',
        controller: 'NSController'
    }).when('/NE', {
        templateUrl: 'view/NE.html',
        controller: 'NEController'
    }).when('/CC', {
        templateUrl: 'view/CC.html',
        controller: 'CCController'
    }).when('/DT', {
        templateUrl: 'view/DT.html',
        controller: 'DTController'
    }).
      otherwise({
        redirectTo: '/NS'
      });
}])

.factory('Train', function() {

  return {
   
    getLastActiveIndex: function() {
      return parseInt(window.localStorage['lastActiveProject']) || 0;
    },
    setLastActiveIndex: function(index) {
      window.localStorage['lastActiveProject'] = index;
    }
  }
})

.controller('EWController', function($scope,$ionicLoading) {
     
     $scope.hide();
})

.controller('NSController', function($scope,$ionicLoading) {
     
     $scope.hide();
})

.controller('NEController', function($scope,$ionicLoading) {
     
     $scope.hide();
})

.controller('CCController', function($scope,$ionicLoading) {
     
     $scope.hide();
})

.controller('DTController', function($scope,$ionicLoading) {
     
     $scope.hide();
})

.controller('MrtCtrl', function($scope,servicejs,$ionicActionSheet,$ionicLoading,$ionicModal) {

  $scope.show = function() {

    // Show the loading overlay and text
    $scope.loading = $ionicLoading.show({

      // The text to display in the loading indicator
      content: 'Loading',

      // The animation to use
      animation: 'fade-in',

      // Will a dark overlay or backdrop cover the entire view
      showBackdrop: true,

      // The maximum width of the loading indicator
      // Text will be wrapped if longer than maxWidth
      maxWidth: 200,

      // The delay in showing the indicator
      showDelay: 0
    });
  };

  // Hide the loading indicator
  $scope.hide = function(){
    $scope.loading.hide();
  };
	
  $ionicModal.fromTemplateUrl('view/mall.html', function(modal) {
    $scope.mallModal = modal;
  }, {
    scope: $scope,
    animation: 'slide-in-up'
  });
  
  $scope.trainClick = function(selectedTrain) {
  
    $scope.buildingNearTrain = '';
   
    if($scope.type == 'Shopping Mall'){
		if(selectedTrain.mall == ''){
			return;
		}else{
		 var buildingString = window.localStorage.getItem(selectedTrain.code+"_mall");
		
		  if(buildingString) {
			var building =  angular.fromJson(buildingString);
			$scope.buildingNearTrain = building[0];
		  }
		}
	}else if($scope.type == 'Library'){
		if(selectedTrain.library == ''){
			return;
		}
	}
	
	
	  
    $scope.selectedTrain = selectedTrain;
    $scope.mallModal.show();
  };
  
  $scope.closeTrainClick = function() {
    $scope.mallModal.hide();
  }
  
 $scope.show();
 
 servicejs.dataOutdated();
  var outdated = window.localStorage['outdated'];
  
     if(!outdated) {

		$scope.show();
		servicejs.init($scope);
		
        //servicejs.selectAllTrainLine($scope);
      }else{
	  $scope.show();
	servicejs.selectAllTrainLine($scope);
	}
  
 
  
  $scope.toggleMenu = function() {
	$scope.sideMenuController.toggleLeft();
  };

  
  $scope.selectLine = function(line, index) {
  
	if($scope.activeLine.code == line.code){
		$scope.sideMenuController.close();
		return;
	}
	
	if(line.code == 'EW'){
		line.header = 'bar-balanced';
		
		if($scope.EW.length == 0){
			servicejs.init($scope);
		}
	}else if(line.code == 'NS'){
		line.header = 'bar-assertive';
		
		if($scope.NS.length == 0){
			servicejs.init($scope);
		}
	}else if(line.code == 'NE'){
		line.header = 'bar-royal';
		
		if($scope.NE.length == 0){
			servicejs.init($scope);
		}
	}else if(line.code == 'CC'){
		line.header = 'bar-energized';
		
		if($scope.CC.length == 0){
			servicejs.init($scope);
		}
	}else if(line.code == 'DT'){
		line.header = 'bar-positive';
		
		if($scope.DT.length == 0){
			servicejs.init($scope);
		}
	}
	
	
	 $scope.activeLine = line;
	$scope.sideMenuController.close();
	$scope.show();
	
	
  };
  
  $scope.actionShow = function() {

    // Show the action sheet
    $ionicActionSheet.show({

      // The various non-destructive button choices
      buttons: [
        { text: 'Shopping Mall' },
        //{ text: 'Library' },
      ],


      // The title text at the top
      titleText: 'Select nearby',

      // The text of the cancel button
      cancelText: 'Cancel',

      // Called when the sheet is cancelled, either from triggering the
      // cancel button, or tapping the backdrop, or using escape on the keyboard
      cancel: function() {
      },

      // Called when one of the non-destructive buttons is clicked, with
      // the index of the button that was clicked. Return
      // "true" to tell the action sheet to close. Return false to not close.
      buttonClicked: function(index) {
	  
	    if(index == 0){
			$scope.type = 'Shopping Mall';
		}else if(index == 1){
			$scope.type = 'Library';
		}
		
        return true;
      },

      
    });

  };
});

